#include <cstdio>

long long int Q,N,a[200000],z1,z2,s,v=0,t,i1,i2;

int main()
{
    scanf("%lld %lld",&N,&Q);
    for(long long int i=0;i<N;i++)
        {
            scanf("%lld",&a[i]);
            if(a[i]>1)
                v=1;
        }
    for(long long int i=0;i<Q;i++)
    {
        scanf("%lld %lld",&z1,&z2);
        if(!v)
        {

        {
            t=0;
            i1=z1-1;
            i2=z2;
            for(long long int j=i1;j<i2;j++)
            {
                if(!a[j])
                {
                    t=1;
                    break;
                }
            }
            if(t)
                printf("0\n");
            else
                printf("1\n");
        }
        }
        else
        {
        {
        if(z1!=z2)
        s=a[z1-1]&a[z1];
        else
            s=a[z1-1];
        for(long long int j=z1+1;j<z2;j++)
            s=s&a[j];
        printf("%lld\n",s);
        }
        }
    }
    return 0;
}